#pragma once

#include "IPlatformWindow.h"

class XcbImage;
struct xcb_connection_t;

namespace mt
{
    class Window;
}

class XcbWindow : public IPlatformWindow
{
public:
    XcbWindow(mt::Window* window, int hwnd, xcb_connection_t* connection);
    virtual ~XcbWindow() = default;

    static void add(mt::Window* window, xcb_connection_t* connection, mt::Screen* screen, uint32_t eventMask);

    int getHandle() const;
    unsigned getGraphicsContext() const;

    void show() const override;

    void paint(mt::Screen* screen) override;

    void clear() const override;

    void map() const override;

private:
    int mHandle{-1};
    unsigned mGraphicsContext {0};
    xcb_connection_t* mConnection{nullptr};
    std::unique_ptr<XcbImage> mBackingImage;
};

using XcbWindowPtr = std::unique_ptr<XcbWindow>;

